Index: /LMDZ5/branches/testing/libf/phylmd/cva_driver.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/cva_driver.F90	(revision 2869)
+++ /LMDZ5/branches/testing/libf/phylmd/cva_driver.F90	(revision 2870)
@@ -39,5 +39,4 @@
 ! **************************************************************
 
-  USE dimphy
   USE print_control_mod, ONLY: prt_level, lunout
   IMPLICIT NONE
@@ -168,5 +167,5 @@
   INTEGER, INTENT (IN)                               :: ndp1
   INTEGER, INTENT (IN)                               :: ntra
-  INTEGER, INTENT(IN)                                :: nloc ! (nloc=klon)  pour l'instant
+  INTEGER, INTENT(IN)                                :: nloc ! (nloc=len)  pour l'instant
   INTEGER, INTENT (IN)                               :: k_upper
   INTEGER, INTENT (IN)                               :: iflag_con
@@ -219,17 +218,17 @@
   REAL, DIMENSION (len), INTENT (OUT)                :: ptop21
   REAL, DIMENSION (len), INTENT (OUT)                :: sigd1
-  REAL, DIMENSION (len, nd), INTENT (OUT)            :: ma1
-  REAL, DIMENSION (len, nd), INTENT (OUT)            :: mip1
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: ma1        ! adiab. asc. mass flux (staggered grid)
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: mip1       ! mass flux shed from adiab. ascent (extensive)
 ! real Vprecip1(len,nd)
-  REAL, DIMENSION (len, ndp1), INTENT (OUT)          :: vprecip1
-  REAL, DIMENSION (len, ndp1), INTENT (OUT)          :: vprecipi1
-  REAL, DIMENSION (len, nd), INTENT (OUT)            :: upwd1
-  REAL, DIMENSION (len, nd), INTENT (OUT)            :: dnwd1
-  REAL, DIMENSION (len, nd), INTENT (OUT)            :: dnwd01
-  REAL, DIMENSION (len, nd), INTENT (OUT)            :: qcondc1         ! cld
+  REAL, DIMENSION (len, ndp1), INTENT (OUT)          :: vprecip1   ! tot precipitation flux (staggered grid)
+  REAL, DIMENSION (len, ndp1), INTENT (OUT)          :: vprecipi1  ! ice precipitation flux (staggered grid)
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: upwd1      ! upwd sat. mass flux (staggered grid)
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: dnwd1      ! dnwd sat. mass flux (staggered grid)
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: dnwd01     ! unsat. mass flux (staggered grid)
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: qcondc1    ! max cloud condensate (intensive)  ! cld
   REAL, DIMENSION (len), INTENT (OUT)                :: wd1             ! gust
   REAL, DIMENSION (len), INTENT (OUT)                :: cape1
   REAL, DIMENSION (len), INTENT (OUT)                :: cin1
-  REAL, DIMENSION (len, nd), INTENT (OUT)            :: tvp1
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: tvp1       ! Virt. temp. in the adiab. ascent
 
 !AC!
@@ -237,28 +236,32 @@
 !!      real da(len,nd),phi(len,nd,nd)
 !AC!
-  REAL, DIMENSION (len, nd), INTENT (OUT)            :: ftd1
-  REAL, DIMENSION (len, nd), INTENT (OUT)            :: fqd1
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: ftd1       ! Temp. tendency due to the sole unsat. drafts
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: fqd1       ! Moist. tendency due to the sole unsat. drafts
   REAL, DIMENSION (len), INTENT (OUT)                :: Plim11
   REAL, DIMENSION (len), INTENT (OUT)                :: Plim21
-  REAL, DIMENSION (len, nd), INTENT (OUT)            :: asupmax1
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: asupmax1   ! Highest mixing fraction of mixed updraughts
   REAL, DIMENSION (len), INTENT (OUT)                :: supmax01
   REAL, DIMENSION (len), INTENT (OUT)                :: asupmaxmin1
-  REAL, DIMENSION (len, nd), INTENT (OUT)            :: qtc1            ! cld
-  REAL, DIMENSION (len, nd), INTENT (OUT)            :: sigt1           ! cld
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: qtc1    ! in cloud water content (intensive)   ! cld
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: sigt1   ! fract. cloud area (intensive)        ! cld
 
 ! RomP >>>
-  REAL, DIMENSION (len, nd), INTENT (OUT)            :: wdtrainA1, wdtrainM1
-  REAL, DIMENSION (len, nd), INTENT (OUT)            :: da1, mp1
-  REAL, DIMENSION (len, nd, nd), INTENT (OUT)        :: phi1
-  REAL, DIMENSION (len, nd, nd), INTENT (OUT)        :: epmlmMm1
-  REAL, DIMENSION (len, nd), INTENT (OUT)            :: eplaMm1
-  REAL, DIMENSION (len, nd), INTENT (OUT)            :: evap1, ep1
-  REAL, DIMENSION (len, nd, nd), INTENT (OUT)        :: sigij1, elij1
-  REAL, DIMENSION (len, nd), INTENT (OUT)            :: clw1
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: wdtrainA1, wdtrainM1 ! precipitation sources (extensive)
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: mp1  ! unsat. mass flux (staggered grid)
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: da1  ! detrained mass flux of adiab. asc. air (extensive)
+  REAL, DIMENSION (len, nd, nd), INTENT (OUT)        :: phi1 ! mass flux of envt. air in mixed draughts (extensive)
+  REAL, DIMENSION (len, nd, nd), INTENT (OUT)        :: epmlmMm1  ! (extensive)
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: eplaMm1   ! (extensive)
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: evap1 ! evaporation rate in precip. downdraft. (intensive)
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: ep1
+  REAL, DIMENSION (len, nd, nd), INTENT (OUT)        :: sigij1 ! mass fraction of env. air in mixed draughts (intensive) 
+  REAL, DIMENSION (len, nd, nd), INTENT (OUT)        :: elij1! cond. water per unit mass of mixed draughts (intensive) 
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: clw1 ! cond. water per unit mass of the adiab. asc. (intensive) 
 !JYG,RL
-  REAL, DIMENSION (len, nd), INTENT (OUT)            :: wghti1      ! final weight of the feeding layers
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: wghti1   ! final weight of the feeding layers (extensive)
 !JYG,RL
-  REAL, DIMENSION (len, nd, nd), INTENT (OUT)        :: phi21
-  REAL, DIMENSION (len, nd), INTENT (OUT)            :: d1a1, dam1
+  REAL, DIMENSION (len, nd, nd), INTENT (OUT)        :: phi21    ! (extensive)
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: d1a1     ! (extensive)
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: dam1     ! (extensive)
 ! RomP <<<
   REAL, DIMENSION (len ), INTENT (OUT)               :: epmax_diag1      
@@ -395,10 +398,10 @@
 
 
-  INTEGER i, k, n, il, j
+  INTEGER i, k, il
   INTEGER nword1, nword2, nword3, nword4
   INTEGER icbmax
-  INTEGER nk1(klon)
-  INTEGER icb1(klon)
-  INTEGER icbs1(klon)
+  INTEGER nk1(len)
+  INTEGER icb1(len)
+  INTEGER icbs1(len)
 
   LOGICAL ok_inhib ! True => possible inhibition of convection by dryness
@@ -407,33 +410,30 @@
 
   REAL coef_convective(len)   ! = 1 for convective points, = 0 otherwise
-  REAL tnk1(klon)
-  REAL thnk1(klon)
-  REAL qnk1(klon)
-  REAL gznk1(klon)
-  REAL pnk1(klon)
-  REAL qsnk1(klon)
-  REAL unk1(klon)
-  REAL vnk1(klon)
-  REAL cpnk1(klon)
-  REAL hnk1(klon)
-  REAL pbase1(klon)
-  REAL buoybase1(klon)
-
-  REAL lf1(klon, klev), lf1_wake(klon, klev)
-  REAL lv1(klon, klev), lv1_wake(klon, klev)
-  REAL cpn1(klon, klev), cpn1_wake(klon, klev)
-  REAL tv1(klon, klev), tv1_wake(klon, klev)
-  REAL gz1(klon, klev), gz1_wake(klon, klev)
-  REAL hm1(klon, klev), hm1_wake(klon, klev)
-  REAL h1(klon, klev), h1_wake(klon, klev)
-  REAL tp1(klon, klev)
-  REAL th1(klon, klev), th1_wake(klon, klev)
-
-  REAL bid(klon, klev) ! dummy array
+  REAL tnk1(len)
+  REAL thnk1(len)
+  REAL qnk1(len)
+  REAL gznk1(len)
+  REAL qsnk1(len)
+  REAL unk1(len)
+  REAL vnk1(len)
+  REAL cpnk1(len)
+  REAL hnk1(len)
+  REAL pbase1(len)
+  REAL buoybase1(len)
+
+  REAL lf1(len, nd), lf1_wake(len, nd)
+  REAL lv1(len, nd), lv1_wake(len, nd)
+  REAL cpn1(len, nd), cpn1_wake(len, nd)
+  REAL tv1(len, nd), tv1_wake(len, nd)
+  REAL gz1(len, nd), gz1_wake(len, nd)
+  REAL hm1(len, nd)
+  REAL h1(len, nd), h1_wake(len, nd)
+  REAL tp1(len, nd)
+  REAL th1(len, nd), th1_wake(len, nd)
+
+  REAL bid(len, nd) ! dummy array
 
   INTEGER ncum
 
-  INTEGER j1feed(klon)
-  INTEGER j2feed(klon)
   REAL p1feed1(len) ! pressure at lower bound of feeding layer
   REAL p2feed1(len) ! pressure at upper bound of feeding layer
@@ -450,66 +450,65 @@
 !>jyg
   INTEGER iflag(nloc), nk(nloc), icb(nloc)
-  INTEGER nent(nloc, klev)
+  INTEGER nent(nloc, nd)
   INTEGER icbs(nloc)
   INTEGER inb(nloc), inbis(nloc)
 
   REAL cbmf(nloc), plcl(nloc), plfc(nloc), wbeff(nloc)
-  REAL t(nloc, klev), q(nloc, klev), qs(nloc, klev)
-  REAL t_wake(nloc, klev), q_wake(nloc, klev), qs_wake(nloc, klev)
+  REAL t(nloc, nd), q(nloc, nd), qs(nloc, nd)
+  REAL t_wake(nloc, nd), q_wake(nloc, nd), qs_wake(nloc, nd)
   REAL s_wake(nloc)
-  REAL u(nloc, klev), v(nloc, klev)
-  REAL gz(nloc, klev), h(nloc, klev), hm(nloc, klev)
-  REAL h_wake(nloc, klev), hm_wake(nloc, klev)
-  REAL lv(nloc, klev), lf(nloc, klev), cpn(nloc, klev)
-  REAL lv_wake(nloc, klev), lf_wake(nloc, klev), cpn_wake(nloc, klev)
-  REAL p(nloc, klev), ph(nloc, klev+1), tv(nloc, klev), tp(nloc, klev)
-  REAL tv_wake(nloc, klev)
-  REAL clw(nloc, klev)
-  REAL dph(nloc, klev)
-  REAL pbase(nloc), buoybase(nloc), th(nloc, klev)
-  REAL th_wake(nloc, klev)
-  REAL tvp(nloc, klev)
-  REAL sig(nloc, klev), w0(nloc, klev), ptop2(nloc)
-  REAL hp(nloc, klev), ep(nloc, klev), sigp(nloc, klev)
-  REAL buoy(nloc, klev)
+  REAL u(nloc, nd), v(nloc, nd)
+  REAL gz(nloc, nd), h(nloc, nd)
+  REAL h_wake(nloc, nd)
+  REAL lv(nloc, nd), lf(nloc, nd), cpn(nloc, nd)
+  REAL lv_wake(nloc, nd), lf_wake(nloc, nd), cpn_wake(nloc, nd)
+  REAL p(nloc, nd), ph(nloc, nd+1), tv(nloc, nd), tp(nloc, nd)
+  REAL tv_wake(nloc, nd)
+  REAL clw(nloc, nd)
+  REAL dph(nloc, nd)
+  REAL pbase(nloc), buoybase(nloc), th(nloc, nd)
+  REAL th_wake(nloc, nd)
+  REAL tvp(nloc, nd)
+  REAL sig(nloc, nd), w0(nloc, nd), ptop2(nloc)
+  REAL hp(nloc, nd), ep(nloc, nd), sigp(nloc, nd)
+  REAL buoy(nloc, nd)
   REAL cape(nloc)
   REAL cin(nloc)
-  REAL m(nloc, klev)
-  REAL ment(nloc, klev, klev), sigij(nloc, klev, klev)
-  REAL qent(nloc, klev, klev)
-  REAL hent(nloc, klev, klev)
-  REAL uent(nloc, klev, klev), vent(nloc, klev, klev)
-  REAL ments(nloc, klev, klev), qents(nloc, klev, klev)
-  REAL elij(nloc, klev, klev)
-  REAL supmax(nloc, klev)
+  REAL m(nloc, nd)
+  REAL ment(nloc, nd, nd), sigij(nloc, nd, nd)
+  REAL qent(nloc, nd, nd)
+  REAL hent(nloc, nd, nd)
+  REAL uent(nloc, nd, nd), vent(nloc, nd, nd)
+  REAL ments(nloc, nd, nd), qents(nloc, nd, nd)
+  REAL elij(nloc, nd, nd)
+  REAL supmax(nloc, nd)
   REAL Ale(nloc), Alp(nloc), coef_clos(nloc)
-  REAL omega(nloc,klev)
+  REAL omega(nloc,nd)
   REAL sigd(nloc)
-! real mp(nloc,klev), qp(nloc,klev), up(nloc,klev), vp(nloc,klev)
-! real wt(nloc,klev), water(nloc,klev), evap(nloc,klev), ice(nloc,klev)
-! real b(nloc,klev), sigd(nloc)
+! real mp(nloc,nd), qp(nloc,nd), up(nloc,nd), vp(nloc,nd)
+! real wt(nloc,nd), water(nloc,nd), evap(nloc,nd), ice(nloc,nd)
+! real b(nloc,nd), sigd(nloc)
 ! save mp,qp,up,vp,wt,water,evap,b
-  REAL, SAVE, ALLOCATABLE :: mp(:, :), qp(:, :), up(:, :), vp(:, :)
-  REAL, SAVE, ALLOCATABLE :: wt(:, :), water(:, :), evap(:, :)
-  REAL, SAVE, ALLOCATABLE :: ice(:, :), fondue(:, :), b(:, :)
-  REAL, SAVE, ALLOCATABLE :: frac(:, :), faci(:, :)
-!$OMP THREADPRIVATE(mp,qp,up,vp,wt,water,evap,ice,fondue,b,frac,faci)
-  REAL ft(nloc, klev), fq(nloc, klev)
-  REAL ftd(nloc, klev), fqd(nloc, klev)
-  REAL fu(nloc, klev), fv(nloc, klev)
-  REAL upwd(nloc, klev), dnwd(nloc, klev), dnwd0(nloc, klev)
-  REAL ma(nloc, klev), mip(nloc, klev)
-!!  REAL tls(nloc, klev), tps(nloc, klev)                 ! unused . jyg
+  REAL, DIMENSION(len,nd)     :: mp, qp, up, vp
+  REAL, DIMENSION(len,nd)     :: wt, water, evap
+  REAL, DIMENSION(len,nd)     :: ice, fondue, b
+  REAL, DIMENSION(len,nd)     :: frac, faci
+  REAL ft(nloc, nd), fq(nloc, nd)
+  REAL ftd(nloc, nd), fqd(nloc, nd)
+  REAL fu(nloc, nd), fv(nloc, nd)
+  REAL upwd(nloc, nd), dnwd(nloc, nd), dnwd0(nloc, nd)
+  REAL ma(nloc, nd), mip(nloc, nd)
+!!  REAL tls(nloc, nd), tps(nloc, nd)                 ! unused . jyg
   REAL qprime(nloc), tprime(nloc)
   REAL precip(nloc)
-! real Vprecip(nloc,klev)
-  REAL vprecip(nloc, klev+1)
-  REAL vprecipi(nloc, klev+1)
-  REAL tra(nloc, klev, ntra), trap(nloc, klev, ntra)
-  REAL ftra(nloc, klev, ntra), traent(nloc, klev, klev, ntra)
-  REAL qcondc(nloc, klev)      ! cld
+! real Vprecip(nloc,nd)
+  REAL vprecip(nloc, nd+1)
+  REAL vprecipi(nloc, nd+1)
+  REAL tra(nloc, nd, ntra), trap(nloc, nd, ntra)
+  REAL ftra(nloc, nd, ntra), traent(nloc, nd, nd, ntra)
+  REAL qcondc(nloc, nd)      ! cld
   REAL wd(nloc)                ! gust
   REAL Plim1(nloc), plim2(nloc)
-  REAL asupmax(nloc, klev)
+  REAL asupmax(nloc, nd)
   REAL supmax0(nloc)
   REAL asupmaxmin(nloc)
@@ -519,11 +518,11 @@
   REAL hnk(nloc), unk(nloc), vnk(nloc)
 
-  REAL qtc(nloc, klev)         ! cld
-  REAL sigt(nloc, klev)        ! cld
+  REAL qtc(nloc, nd)         ! cld
+  REAL sigt(nloc, nd)        ! cld
  
 ! RomP >>>
-  REAL wdtrainA(nloc, klev), wdtrainM(nloc, klev)
+  REAL wdtrainA(nloc, nd), wdtrainM(nloc, nd)
   REAL da(len, nd), phi(len, nd, nd)
-  REAL epmlmMm(nloc, klev, klev), eplaMm(nloc, klev)
+  REAL epmlmMm(nloc, nd, nd), eplaMm(nloc, nd)
   REAL phi2(len, nd, nd)
   REAL d1a(len, nd), dam(len, nd)
@@ -531,6 +530,4 @@
   REAL epmax_diag(nloc) ! epmax_cape
 
-  LOGICAL, SAVE :: first = .TRUE.
-!$OMP THREADPRIVATE(first)
   CHARACTER (LEN=20) :: modname = 'cva_driver'
   CHARACTER (LEN=80) :: abort_message
@@ -540,6 +537,6 @@
 
 
-! print *, 't1, t1_wake ',(k,t1(1,k),t1_wake(1,k),k=1,klev)
-! print *, 'q1, q1_wake ',(k,q1(1,k),q1_wake(1,k),k=1,klev)
+! print *, 't1, t1_wake ',(k,t1(1,k),t1_wake(1,k),k=1,nd)
+! print *, 'q1, q1_wake ',(k,q1(1,k),q1_wake(1,k),k=1,nd)
 
 ! -------------------------------------------------------------------
@@ -547,12 +544,4 @@
 ! -------------------------------------------------------------------
 
-  IF (first) THEN
-    ALLOCATE (mp(nloc,klev), qp(nloc,klev), up(nloc,klev))
-    ALLOCATE (vp(nloc,klev), wt(nloc,klev), water(nloc,klev))
-    ALLOCATE (ice(nloc,klev), fondue(nloc,klev))
-    ALLOCATE (evap(nloc,klev), b(nloc,klev))
-    ALLOCATE (frac(nloc,klev), faci(nloc,klev))
-    first = .FALSE.
-  END IF
 ! -- set simulation flags:
 ! (common cvflag)
@@ -736,5 +725,5 @@
 ! print*, 'IFLAG1 avant cv3_feed'
 ! print*,'len,nd',len,nd
-! write(*,'(64i1)') iflag1(2:klon-1)
+! write(*,'(64i1)') iflag1(2:len-1)
 
         if (prt_level >= 9) &
@@ -749,5 +738,5 @@
 ! print*, 'IFLAG1 apres cv3_feed'
 ! print*,'len,nd',len,nd
-! write(*,'(64i1)') iflag1(2:klon-1)
+! write(*,'(64i1)') iflag1(2:len-1)
 
   IF (iflag_con==4) THEN
@@ -799,5 +788,5 @@
 ! print*, 'IFLAG1 apres cv3_triger'
 ! print*,'len,nd',len,nd
-! write(*,'(64i1)') iflag1(2:klon-1)
+! write(*,'(64i1)') iflag1(2:len-1)
 
 ! call dump2d(iim,jjm-1,sig1(2)
@@ -828,5 +817,5 @@
   END DO
 
-! print*,'klon, ncum = ',len,ncum
+! print*,'len, ncum = ',len,ncum
 
   IF (ncum>0) THEN
@@ -944,5 +933,5 @@
 !      END IF
       IF (iflag_mix>=1) THEN
-        CALL zilch(supmax, nloc*klev)
+        CALL zilch(supmax, nloc*nd)
         if (prt_level >= 9) &
              PRINT *, 'cva_driver -> cv3p_mixing'
@@ -955,5 +944,5 @@
 
       ELSE
-        CALL zilch(supmax, nloc*klev)
+        CALL zilch(supmax, nloc*nd)
       END IF
     END IF
@@ -1031,5 +1020,5 @@
                         unk, vnk, hp, tv, tvp, ep, clw, m, sig, &
                         ment, qent, uent, vent, nent, sigij, elij, ments, qents, traent)
-        CALL zilch(hent, nloc*klev*klev)
+        CALL zilch(hent, nloc*nd*nd)
       ELSE
         CALL cv3_mixscale(nloc, ncum, nd, ment, m)
Index: /LMDZ5/branches/testing/libf/phylmd/dyn1d/1DUTILS.h
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/dyn1d/1DUTILS.h	(revision 2869)
+++ /LMDZ5/branches/testing/libf/phylmd/dyn1d/1DUTILS.h	(revision 2870)
@@ -653,9 +653,12 @@
 
       modname = 'dyn1deta0 : '
-      nmq(1)="vap"
-      nmq(2)="cond"
-      do iq=3,nqtot
-        write(nmq(iq),'("tra",i1)') iq-2
-      enddo
+!!      nmq(1)="vap"
+!!      nmq(2)="cond"
+!!      do iq=3,nqtot
+!!        write(nmq(iq),'("tra",i1)') iq-2
+!!      enddo
+      DO iq = 1,nqtot
+        nmq(iq) = trim(tname(iq))
+      ENDDO
       print*,'in dyn1deta0 ',fichnom,klon,klev,nqtot
       CALL open_startphy(fichnom)
@@ -804,8 +807,11 @@
       CALL open_restartphy(fichnom)
       print*,'redm1 ',fichnom,klon,klev,nqtot
-      nmq(1)="vap"
-      nmq(2)="cond"
-      nmq(3)="tra1"
-      nmq(4)="tra2"
+!!      nmq(1)="vap"
+!!      nmq(2)="cond"
+!!      nmq(3)="tra1"
+!!      nmq(4)="tra2"
+      DO iq = 1,nqtot
+        nmq(iq) = trim(tname(iq))
+      ENDDO
 
       modname = 'dyn1dredem'
Index: /LMDZ5/branches/testing/libf/phylmd/ener_conserv.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/ener_conserv.F90	(revision 2869)
+++ /LMDZ5/branches/testing/libf/phylmd/ener_conserv.F90	(revision 2870)
@@ -1,4 +1,5 @@
 subroutine ener_conserv(klon,klev,pdtphys, &
- &    puo,pvo,pto,pqo,pun,pvn,ptn,pqn,dtke,masse,exner,d_t_ec)
+ &                      puo,pvo,pto,pqo,pql0,pqs0, &
+ &                      pun,pvn,ptn,pqn,pqln,pqsn,dtke,masse,exner,d_t_ec)
 
 !=============================================================
@@ -19,5 +20,6 @@
 
 ! From module
-USE phys_local_var_mod, ONLY : d_u_vdf,d_v_vdf,d_t_vdf,d_u_ajs,d_v_ajs,d_t_ajs,d_u_con,d_v_con,d_t_con,d_t_diss
+USE phys_local_var_mod, ONLY : d_u_vdf,d_v_vdf,d_t_vdf,d_u_ajs,d_v_ajs,d_t_ajs, &
+ &                             d_u_con,d_v_con,d_t_con,d_t_diss
 USE phys_local_var_mod, ONLY : d_t_eva,d_t_lsc,d_q_eva,d_q_lsc
 USE phys_output_var_mod, ONLY : bils_ec,bils_ech,bils_tke,bils_kinetic,bils_enthalp,bils_latent,bils_diss
@@ -32,12 +34,13 @@
 INTEGER, INTENT(IN) :: klon,klev
 REAL, INTENT(IN) :: pdtphys
-REAL, DIMENSION(klon,klev),INTENT(IN) :: puo,pvo,pto,pqo
-REAL, DIMENSION(klon,klev),INTENT(IN) :: pun,pvn,ptn,pqn
-REAL, DIMENSION(klon,klev),INTENT(IN) :: masse,exner
-REAL, DIMENSION(klon,klev+1),INTENT(IN) :: dtke
-REAL, DIMENSION(klon,klev),INTENT(OUT) :: d_t_ec
-      integer k,i
+REAL, DIMENSION(klon,klev), INTENT(IN)      :: puo,pvo,pto,pqo,pql0,pqs0
+REAL, DIMENSION(klon,klev), INTENT(IN)      :: pun,pvn,ptn,pqn,pqln,pqsn
+REAL, DIMENSION(klon,klev), INTENT(IN)      :: masse,exner
+REAL, DIMENSION(klon,klev+1), INTENT(IN)    :: dtke
+!
+REAL, DIMENSION(klon,klev), INTENT(OUT)     :: d_t_ec
 
 ! Local
+      integer k,i
 REAL, DIMENSION(klon,klev+1) :: fluxu,fluxv,fluxt
 REAL, DIMENSION(klon,klev+1) :: dddu,dddv,dddt
@@ -56,5 +59,5 @@
    DO k = 1, klev
    DO i = 1, klon
-      ZRCPD = RCPD*(1.0+RVTMP2*pqn(i,k))
+      ZRCPD = RCPD*(1.0+RVTMP2*(pqn(i,k)+pqln(i,k)+pqsn(i,k)))
       d_t_ec(i,k)=0.5/ZRCPD &
  &      *(puo(i,k)**2+pvo(i,k)**2-pun(i,k)**2-pvn(i,k)**2)
